#!/bin/sh

DEBUG=false
GPS=false
INCLUDEUNVISITED=true
INCLUDELRUD=false
INCLUDEPOSSIBLYTOOTIGHT=true
INCLUDEONLYPATH="all"
INCLUDEDISCONNECTEDCAVEPARTS=false
EXCLUDE=none
MAXOKLENGTH=10

while [ "x`echo x$1 | cut -c2-3`" = x-- ]
do
  
  case "x$1" in

  x--debug)
    DEBUG=true
    shift;;

  x--max-ok-length)
    shift
    MAXOKLENGTH="$1"
    shift;;

  x--gps)
    GPS=true
    shift;;
  
  x--no-gps)
    GPS=false
    shift;;
  
  x--include-lrud)
    INCLUDELRUD=true
    shift;;
  
  x--exclude-lrud)
    INCLUDELRUD=false
    shift;;

  x--include-unvisited)
    INCLUDEUNVISITED=true
    shift;;
  
  x--exclude-unvisited)
    INCLUDEUNVISITED=false
    shift;;

  x--include-possibly-too-tight)
    INCLUDEPOSSIBLYTOOTIGHT=true
    shift;;
  
  x--exclude-possibly-too-tight)
    INCLUDEPOSSIBLYTOOTIGHT=false
    shift;;

  x--include-disconnected-cave-parts)
    INCLUDEDISCONNECTEDCAVEPARTS=true
    shift;;
  
  x--exclude-disconnected-cave-parts)
    INCLUDEDISCONNECTEDCAVEPARTS=false
    shift;;

  x--include-only-path)
    shift
    INCLUDEONLYPATH="$1"
    shift;;

  x--exclude)
    shift
    EXCLUDE="$1"
    shift;;

  *)
    echo cavform2survex.sh: unrecognised option $1 -- exit
    exit 1;;

  esac

done

if [ $# = 1 ]
then
  INPUT=$1
else
  echo cavform2survex.sh: expecting a .cavf file as an argument -- exit
  exit 1
fi

jsc cavform.js cavform2survex.js \
    -e "Cavform2Survex({ debug: $DEBUG, gps: $GPS, exclude: "'"'"$EXCLUDE"'"'", includeonlypath: "'"'"$INCLUDEONLYPATH"'"'", includeunvisited: $INCLUDEUNVISITED, includedisconnected: $INCLUDEDISCONNECTEDCAVEPARTS, includelrud: $INCLUDELRUD, includepossiblytootight: $INCLUDEPOSSIBLYTOOTIGHT },Cavform({ debug: $DEBUG, maxoklength: $MAXOKLENGTH })); print('Ok.');" < $INPUT > /tmp/cavform2survex.tmp

LASTLINE="`tail -1 /tmp/cavform2survex.tmp`"
LINES=`cat /tmp/cavform2survex.tmp | wc -l | tr -d " "`
LINESMINONE=`expr $LINES - 1`
GPROPFILE=`echo $INPUT | sed 's/.cavf/.gprop/'`

# echo INPUT = $INPUT
# echo GPROPFILE = $GPROPFILE

if [ x"$LASTLINE" = "xOk." ]
then
  head -$LINESMINONE /tmp/cavform2survex.tmp > /tmp/cavform2survex.tmp2
  grep "graphproperty:" /tmp/cavform2survex.tmp2 | cut -f2- -d: > $GPROPFILE
  grep -v "graphproperty:" /tmp/cavform2survex.tmp2
  exit 0
else
  tail -10 /tmp/cavform2survex.tmp 1>&2
  exit 1
fi
